org.h2.bnf

## Interface BnfVisitor

All Known Implementing Classes:
  BnfRailroad, BnfRandom, BnfSyntax

    public interface BnfVisitor

The visitor interface for BNF rules.

### Method Summary

Methods
`void` `visitRuleElement(boolean keyword, java.lang.String name, Rule link)` Visit a rule element.
`void` `visitRuleFixed(int type)` Visit a fixed rule.
`void` `visitRuleList(boolean or, java.util.ArrayList<Rule> list)` Visit a rule list.
`void` `visitRuleOptional(Rule rule)` Visit an optional rule.
`void` `visitRuleRepeat(boolean comma, Rule rule)` Visit a repeat rule.

### Method Detail

#### visitRuleElement

    void visitRuleElement(boolean keyword,
                        java.lang.String name,
                        Rule link)

Visit a rule element.

Parameters:
  `keyword` - whether this is a keyword
  `name` - the element name
  `link` - the linked rule if it's not a keyword

#### visitRuleRepeat

    void visitRuleRepeat(boolean comma,
                       Rule rule)

Visit a repeat rule.

Parameters:
  `comma` - whether the comma is repeated as well
  `rule` - the element to repeat

#### visitRuleFixed

    void visitRuleFixed(int type)

Visit a fixed rule.

Parameters:
  `type` - the type

#### visitRuleList

    void visitRuleList(boolean or,
                     java.util.ArrayList<Rule> list)

Visit a rule list.

Parameters:
  `or` - true for OR, false for AND
  `list` - the rules

#### visitRuleOptional

    void visitRuleOptional(Rule rule)

Visit an optional rule.

Parameters:
  `rule` - the rule